diff --git src/daemon/common/commonSwarming.ml src/daemon/common/commonSwarming.ml
index 1e018f7..a044c59 100644
--- src/daemon/common/commonSwarming.ml
+++ src/daemon/common/commonSwarming.ml
@@ -2838,24 +2933,24 @@ let present_intervals s =
       match intervals with
       | [] -> [interval]
       | (last_interval_begin, last_interval_end) :: other_intervals  ->
-	  if last_interval_end < interval_begin then
-	    interval :: intervals
-	  else 
-	    (* coalescing intervals *)
-	    (last_interval_begin, interval_end) :: other_intervals in
+          if last_interval_end < interval_begin then
+            interval :: intervals
+          else 
+            (* coalescing intervals *)
+            (last_interval_begin, interval_end) :: other_intervals in
 
   List.rev (
     Array2.fold_lefti (fun acc i b -> 
       match s.s_blocks.(i) with
       | EmptyBlock -> acc
       | CompleteBlock | VerifiedBlock ->
-	  append_interval (compute_block_begin s i, compute_block_end s i) acc
+          append_interval (compute_block_begin s i, compute_block_end s i) acc
       | PartialBlock b ->
-	  let acc, last_interval_end =
-	    block_ranges_fold (fun (acc,  lie) r ->
-	      (append_interval (lie, r.range_begin) acc, r.range_end)
-	    ) (acc, compute_block_begin s i) b in
-	  append_interval (last_interval_end, compute_block_end s i) acc
+          let acc, last_interval_end =
+            block_ranges_fold (fun (acc,  lie) r ->
+              (append_interval (lie, r.range_begin) acc, r.range_end)
+            ) (acc, compute_block_begin s i) b in
+          append_interval (last_interval_end, compute_block_end s i) acc
     ) [] s.s_blocks)
 
 (*************************************************************************)
@@ -2883,7 +2978,7 @@ let propagate_chunk t1 pos1 size destinations =
         (file_best_name t1.t_file) pos1
         (file_best_name t2.t_file) pos2 size;
       Unix32.copy_chunk (file_fd t1.t_file)  (file_fd t2.t_file)
-	pos1 pos2 (Int64.to_int size);
+        pos1 pos2 (Int64.to_int size);
       set_frontend_state_complete t2 j2
     end
   ) destinations
@@ -2898,30 +2993,30 @@ let duplicate_chunks () =
       let nchunks = VB.length t.t_converted_verified_bitmap in
       match t.t_verifier with
       | Verification uids when Array.length uids = nchunks ->
-	  let rec iter j len pos =
+          let rec iter j len pos =
             if j < len then
               let c = {
-		chunk_uid = uids.(j);
-		chunk_size = min (s.s_size -- pos) t.t_chunk_size;
+                chunk_uid = uids.(j);
+                chunk_size = min (s.s_size -- pos) t.t_chunk_size;
               } in
-	      let occurrences = 
-		try
-		  Hashtbl.find chunks c
-		with Not_found ->
+              let occurrences = 
+                try
+                  Hashtbl.find chunks c
+                with Not_found ->
                   let occurrences = dummy_chunk_occurrences () in
                   Hashtbl.add chunks c occurrences;
                   occurrences in
-	      (match VB.get t.t_converted_verified_bitmap j with
-	      | VB.State_missing | VB.State_partial ->
-		occurrences.occurrence_missing <- 
-		  (t, j, pos) :: occurrences.occurrence_missing
-	      | VB.State_complete -> ()
-	      | VB.State_verified ->
-		occurrences.occurrence_present <- 
-		  (t, j, pos) :: occurrences.occurrence_present);
+              (match VB.get t.t_converted_verified_bitmap j with
+              | VB.State_missing | VB.State_partial ->
+                occurrences.occurrence_missing <- 
+                  (t, j, pos) :: occurrences.occurrence_missing
+              | VB.State_complete -> ()
+              | VB.State_verified ->
+                occurrences.occurrence_present <- 
+                  (t, j, pos) :: occurrences.occurrence_present);
               iter (j+1) len (pos ++ t.t_chunk_size)
-	  in
-	  iter 0 (VB.length t.t_converted_verified_bitmap) zero
+          in
+          iter 0 (VB.length t.t_converted_verified_bitmap) zero
       | _ -> ()
     ) s.s_networks
   ) swarmers_by_name;
@@ -2960,7 +3055,7 @@ let chunks_availability t =
       let v = List2.min
         (List.map (fun i -> s.s_availability.(i)) t.t_blocks_of_chunk.(i)) in
       if v < 0 then 0 else
-	if v > 200 then 200 else v))
+        if v > 200 then 200 else v))
 
 let is_interesting up =
   up.up_ncomplete > 0 || up.up_npartial > 0
@@ -2977,7 +3072,7 @@ let value_to_int64_pair v =
   | List [v1;v2] | SmallList [v1;v2] ->
       (value_to_int64 v1, value_to_int64 v2)
   | _ ->
-      failwith "Options: Not an int32 pair"
+      failwith "Options: Not an int64 pair"
 
 (*************************************************************************)
 (*                                                                       *)
@@ -3011,8 +3106,8 @@ let value_to_frontend t assocs =
     
     let total = 
       List.fold_left (fun acc (x,y) ->
-	lprintf_nl "     (%Ld,%Ld);" x y;
-	acc ++ (y -- x)
+        lprintf_nl "     (%Ld,%Ld);" x y;
+        acc ++ (y -- x)
       ) zero p in
     
     lprintf_nl "ERROR: total %Ld" total;
@@ -3029,7 +3124,7 @@ let value_to_frontend t assocs =
   (try
     let file_name = get_value "file_swarmer" value_to_string in
     let s = HS.find swarmers_by_name 
-	{ dummy_swarmer with s_filename = file_name } in
+        { dummy_swarmer with s_filename = file_name } in
     associate primary t s
     (* TODO: make as many checks as possible to ensure the file and the swarmers
        are correctly associed. *)
@@ -3052,7 +3147,7 @@ let value_to_frontend t assocs =
     with Not_found ->
       set_chunks_verified_bitmap t
         (VB.of_string (get_value  "file_all_chunks" value_to_string))
-	
+        
   with e ->
     lprintf_nl "Exception %s while loading bitmap"
       (Printexc2.to_string e);
@@ -3085,7 +3180,7 @@ let value_to_frontend t assocs =
     (try
       let d = get_value "file_downloaded" value_to_int64 in
       if d <> downloaded t && !verbose then
-	debug_wrong_downloaded t present d
+        debug_wrong_downloaded t present d
     with Not_found -> ());
   end;
 
@@ -3114,7 +3209,7 @@ let frontend_to_value t other_vals =
     [("file_present_chunks", List
       (List.map (fun (i1,i2) ->
         SmallList [int64_to_value i1; int64_to_value i2])
-	(present_intervals t)))] 
+        (present_intervals t)))] 
    else []) @
   [("file_downloaded", int64_to_value (downloaded t));
    ("file_chunks_age", List (Array.to_list
@@ -3184,7 +3279,7 @@ let merge f1 f2 =
     | [] -> assert false
     | t1 :: _ ->
         match t1.t_verifier with
-	| NoVerification | VerificationNotAvailable ->
+        | NoVerification | VerificationNotAvailable ->
             failwith "Cannot use first file as a primary for swarming (no verification scheme)"
         | Verification _ | ForceVerification -> t1
   in
@@ -3240,6 +3335,13 @@ let subfiles t =
 
 module SwarmerOption = struct
 
+  let value_to_priority_interval v =
+    match v with
+    | List [v1;p] | SmallList [v1;p] ->
+      (value_to_int64 v1, value_to_int p)
+    | _ -> 
+      failwith "Options: Not a priority interval"
+
     let value_to_swarmer v =
       match v with
       | Module assocs ->
@@ -3247,25 +3349,35 @@ module SwarmerOption = struct
           let file_size = get_value "file_size" value_to_int64 in
           let file_name = get_value "file_name" value_to_string in
           let s = create_swarmer file_name file_size in
-	  (let order =
+          (let order =
             try
               get_value "file_download_random" value_to_bool
             with _ -> true
            in
            s.s_strategy <- if order then AdvancedStrategy else LinearStrategy);
-	  (try
-	    let bitmap = Bitv.of_string (get_value "file_disk_allocation_bitmap"
-	      value_to_string) in
-	    if Bitv.length bitmap = Bitv.length s.s_disk_allocated then
-	      s.s_disk_allocated <- bitmap
-	  with _ -> ());
-	  (* s_disk_allocated missing or inconsistent ? 
-	     set_present will fix it *)
+          (try
+            let bitmap = Bitv.of_string (get_value "file_disk_allocation_bitmap"
+              value_to_string) in
+            if Bitv.length bitmap = Bitv.length s.s_disk_allocated then
+              s.s_disk_allocated <- bitmap
+          with _ -> ());
+          (* s_disk_allocated missing or inconsistent ? 
+             set_present will fix it *)
           let block_sizes = get_value "file_chunk_sizes"
               (value_to_list value_to_int64) in
           List.iter (fun bsize ->
               split_blocks s bsize
           ) block_sizes;
+          let intervals = 
+            try
+              get_value "file_priorities_intervals" (value_to_list value_to_priority_interval) 
+            with Not_found -> [(zero, 1)]
+          in
+          if validate_intervals s.s_size intervals then
+            s.s_priorities_intervals <- intervals
+          else
+            lprintf_nl "Failed to validate priority intervals, using default. File %s" file_name;
+          swarmer_recompute_priorities_bitmap s;
           s
 
       | _ -> assert false
@@ -3274,10 +3386,14 @@ module SwarmerOption = struct
       Module [
         ("file_size", int64_to_value s.s_size);
         ("file_name", string_to_value s.s_filename);
-	("file_disk_allocation_bitmap", string_to_value
-	  (Bitv.to_string s.s_disk_allocated));
+        ("file_disk_allocation_bitmap", string_to_value
+          (Bitv.to_string s.s_disk_allocated));
         ("file_chunk_sizes", list_to_value int64_to_value
             (List.map (fun t -> t.t_chunk_size) s.s_networks));
+        ("file_priorities_intervals", List
+          (List.map 
+            (fun (i_begin, priority) -> SmallList [int64_to_value i_begin; int_to_value priority])
+            s.s_priorities_intervals));
         ("file_download_random", bool_to_value
             (match s.s_strategy with
              | AdvancedStrategy -> true
@@ -3299,35 +3415,35 @@ let check_swarmer s =
     | tprim :: tail ->
         assert(tprim.t_primary);
 
-	VB.iteri (fun i c ->
-	    if c = VB.State_verified then begin
-	      if List.exists (fun j -> VB.get s.s_verified_bitmap j <> VB.State_verified) 
-		tprim.t_blocks_of_chunk.(i) then
+        VB.iteri (fun i c ->
+            if c = VB.State_verified then begin
+              if List.exists (fun j -> VB.get s.s_verified_bitmap j <> VB.State_verified) 
+                tprim.t_blocks_of_chunk.(i) then
                   failwith "Bad propagation of State_verified from primary to swarmer";
             end
             else if List.exists (fun j -> VB.get s.s_verified_bitmap j = VB.State_verified)
-	      tprim.t_blocks_of_chunk.(i) then
+              tprim.t_blocks_of_chunk.(i) then
                 failwith "Swarmer has State_verified not coming from primary";
-	) tprim.t_converted_verified_bitmap;
+        ) tprim.t_converted_verified_bitmap;
 
         let fd = file_fd tprim.t_file in
 
         List.iter (fun t ->
           assert (not t.t_primary);
           assert (file_fd t.t_file == fd);
-	  
-	  VB.iteri (fun i c ->
-	    if c = VB.State_verified then begin
-	      if List.exists (fun j -> VB.get s.s_verified_bitmap j <> VB.State_verified)
-		t.t_blocks_of_chunk.(i) then
+          
+          VB.iteri (fun i c ->
+            if c = VB.State_verified then begin
+              if List.exists (fun j -> VB.get s.s_verified_bitmap j <> VB.State_verified)
+                t.t_blocks_of_chunk.(i) then
                   failwith "State_verified in secondary without State_verified in primary"
-	    end 
-	    else if c = VB.State_complete then begin
-	      if List.exists (fun j -> VB.get s.s_verified_bitmap j <> VB.State_verified)
-		t.t_blocks_of_chunk.(i) then
+            end 
+            else if c = VB.State_complete then begin
+              if List.exists (fun j -> VB.get s.s_verified_bitmap j <> VB.State_verified)
+                t.t_blocks_of_chunk.(i) then
                   failwith "State_complete in secondary without State_verified in primary"
-	    end 
-	  ) t.t_converted_verified_bitmap
+            end 
+          ) t.t_converted_verified_bitmap
         ) tail
   with e ->
     print_s "ERROR" s;
@@ -3361,9 +3477,9 @@ let _ =
        can be verified while downloads are being restored from ini files *)
     let primary_files, secondary_files = 
       List.partition (fun file -> 
-	match file_files file with
-	| primary_file :: _ when primary_file == file -> true
-	| _ -> false) !!CommonComplexOptions.files in
+        match file_files file with
+        | primary_file :: _ when primary_file == file -> true
+        | _ -> false) !!CommonComplexOptions.files in
     CommonComplexOptions.files =:= primary_files @ secondary_files
   );
   set_after_load_hook files_ini (fun _ ->
@@ -3428,6 +3544,38 @@ let _ =
       Printf.bprintf buf "  Storage: %d bytes\n" !storage;
   )
 
+(* functions for priority bitmask *)
+
+let file_swarmer f =
+  HS.find swarmers_by_name { dummy_swarmer with s_filename = file_disk_name f }
+
+(*
+(** set the priority bitmask for each chunk in a file *)
+let set_swarmer_chunk_priorities f priobitmap =
+  let s = file_swarmer f in
+  if String.length priobitmap = VB.length s.s_verified_bitmap then
+    s.s_priorities_bitmap <- priobitmap
+*)
+(** get the priority bitmask for a file (do not mutate the string directly, use swarmer_set_interval) *)
+let get_swarmer_chunk_priorities f =
+  let s = file_swarmer f in
+    s.s_priorities_bitmap
+
+let get_swarmer_chunk_verified f = 
+  let s = file_swarmer f in
+    s.s_verified_bitmap
+
+(*
+let set_swarmer_priorities_intervals f priorities_intervals = 
+  let s = file_swarmer f in
+  s.s_priorities_intervals <- priorities_intervals;
+  swarmer_recompute_priorities_bitmap s
+*)
+
+let swarmer_get_priorities_intervals f = 
+  let s = file_swarmer f in
+  s.s_priorities_intervals
+
 (* using compute_block_num outside of swarming code is probably
    broken, networks supports are aware of chunks, not blocks 
    maybe other block-related functions should be censored in the same
@@ -3435,4 +3583,4 @@ let _ =
    tag block numbers are chunk numbers so they're not inadvertedly
    mistaken for each other ?
 *)
-let compute_block_num = ()
+(* let compute_block_num = () *)
diff --git src/daemon/driver/driverCommands.ml src/daemon/driver/driverCommands.ml
index 2a31efb..422c8db 100644
--- src/daemon/driver/driverCommands.ml
+++ src/daemon/driver/driverCommands.ml
@@ -50,6 +50,8 @@ open DriverInteractive
 open Gettext
 open Autoconf
 
+module VB = VerificationBitmap
+
 let log_prefix = "[dCmd]"
 
 let lprintf_nl fmt =
@@ -3205,11 +3207,12 @@ let _ =
 				\\<td nowrap class=\\\"fbig\\\"\\>\\<a onclick=\\\"javascript:window.location.href='files'\\\"\\>Display all files\\</a\\>\\</td\\>
 				\\<td nowrap class=\\\"fbig\\\"\\>\\<a onClick=\\\"javascript:parent.fstatus.location.href='submit?q=verify_chunks+%d'\\\"\\>Verify chunks\\</a\\>\\</td\\>
 				\\<td nowrap class=\\\"fbig\\\"\\>\\<a onClick=\\\"javascript:window.location.href='preview_download?q=%d'\\\"\\>Preview\\</a\\>\\</td\\>
+				\\<td nowrap class=\\\"fbig\\\"\\>\\<a onClick=\\\"javascript:window.location.href='submit?q=debug_get_download_prio+%d'\\\"\\>Debug\\</a\\>\\</td\\>
 				\\<td nowrap class=\\\"fbig pr\\\"\\>\\<a onclick=\\\"javascript:window.location.reload()\\\"\\>Reload\\</a\\>\\</td\\>
 				\\<td class=downloaded width=100%%\\>\\</td\\>
 				\\</tr\\>\\</table\\>
 				\\</td\\>\\</tr\\>
-				\\<tr\\>\\<td\\>" num num
+				\\<tr\\>\\<td\\>" num num num
                 else begin
                     Printf.bprintf  buf "\\<a href=\\\"files\\\"\\>Display all files\\</a\\>  ";
                     Printf.bprintf  buf "\\<a href=\\\"submit?q=verify_chunks+%d\\\"\\>Verify chunks\\</a\\>  " num;
@@ -3867,6 +3870,96 @@ let _ =
   register_commands "Driver/Xpert"
     [
 
+(*
+      "debug_set_download_prio", Arg_two 
+        (fun arg priostring  o ->
+           let num = int_of_string arg in
+           let file = file_find num in
+             CommonSwarming.set_swarmer_chunk_priorities file priostring;
+             "set prio"
+
+        ), ":\t\t\t\t\tset block download priorities for a file. 0=never download, >0=download largest prio first";
+*)
+
+      "debug_get_download_prio", Arg_one 
+        (fun arg o ->
+           let buf = o.conn_buf in
+           let pr fmt = Printf.bprintf buf fmt in
+           let num = int_of_string arg in
+           let file = file_find num in
+           let swarmer = CommonSwarming.file_swarmer file in
+           let prio = CommonSwarming.get_swarmer_chunk_priorities file in
+           let downloaded = CommonSwarming.get_swarmer_chunk_verified file in
+           pr "\\<code\\>";
+           pr "priorities: ";
+           String.iter (fun c ->
+             let c = max 0 (min 9 (Char.code c)) in
+             let c = Char.chr (c + Char.code '0') in 
+             Buffer.add_char buf c) prio;
+           pr "\n";
+           pr "downloaded: %s\n" (VB.to_string downloaded);
+
+           Unix32.subfile_tree_map (file_fd file)
+           begin fun fname start length current_length ->
+             let stop = if length <> 0L then (start ++ length -- 1L) else start in
+             let blockstart = try CommonSwarming.compute_block_num swarmer start with _ -> 0 in
+             let blockend = try CommonSwarming.compute_block_num swarmer stop with _ -> 0 in
+             pr "sf:%5Ld ef:%5Ld l:%Ld cl:%Ld > sc:%5d ec:%5d filename:%-30s \n" 
+                      start
+                      stop
+                      length
+                      current_length
+                      blockstart
+                      blockend
+                      fname;
+             (*make a chunk downloaded status string for a subfile*)
+             (try 
+                for i = blockstart to blockend do
+                  Buffer.add_char buf (VB.state_to_char (VB.get downloaded i));
+                done;
+                pr "\n";
+              with _ -> ())
+           end;
+           pr "\\</code\\>";
+           "";
+    ), ":\t\t\t\t\tget file block priorities for a file, and show subfile completion status";
+
+    "debug_set_subfile_prio", Arg_multiple 
+      (fun args o ->
+        let buf = o.conn_buf in
+        match args with
+        | filenum :: priochar :: subfilestart :: q ->
+            let filenum = int_of_string filenum in
+            let priochar = int_of_string priochar in
+            let subfilestart = int_of_string subfilestart in
+            let subfileend =
+              match q with
+              | subfileend :: _ -> int_of_string subfileend
+              | _ -> subfilestart in
+            let file = file_find filenum in
+            let swarmer = CommonSwarming.file_swarmer file in
+(*
+            let priostring = 
+              CommonSwarming.get_swarmer_chunk_priorities file in
+*)
+            let subfile1 = Unix32.find_file_index (file_fd file) subfilestart in (*subfilestart is subfile number, not a byte index, so is buggy (??) *) 
+            let subfile2 = Unix32.find_file_index (file_fd file) subfileend in
+            let subfile_pos = function (_,y,_) -> y in
+            let subfile_len = function (_,_,y) -> y in
+            let start = subfile_pos subfile1 in
+            let stop = 
+              subfile_pos subfile2 ++ subfile_len subfile2 
+(*                 -- if subfile_len subfile2 > 0L then 1L else 0L  *)
+            in
+            Printf.bprintf buf "file %s\nstart %Ld stop %Ld prio %u\n" 
+              swarmer.CommonSwarming.s_filename start stop priochar;
+            CommonSwarming.swarmer_set_interval swarmer (start,stop,priochar);
+            (* show file *)
+            execute_command !CommonNetwork.network_commands o "vd" [string_of_int filenum];
+            ""
+        | _ -> bad_number_of_args "" ""
+    ), "debug_set_subfile_prio <download id> <prio> <1st subfile> <optional last subfile>";
+
     "reload_messages", Arg_none (fun o ->
         CommonMessages.load_message_file ();
         "\\<script type=\\\"text/javascript\\\"\\>top.window.location.reload();\\</script\\>"
diff --git src/networks/bittorrent/bTInteractive.ml src/networks/bittorrent/bTInteractive.ml
index eba8f63..8798b7e 100644
--- src/networks/bittorrent/bTInteractive.ml
+++ src/networks/bittorrent/bTInteractive.ml
@@ -209,8 +209,53 @@ let auto_links =
   let re = Str.regexp_case_fold "\\(https?://[a-zA-Z0-9_.!~*'();/?:@&=+$,%-]+\\)" in
   fun s -> Str.global_replace re "\\<a href=\\\"\\1\\\"\\>\\1\\</a\\>" s
 
+(** Get subfiles priorities
+  @return empty list if no swarmer *)
+let get_subfile_priorities file =
+  match try CommonSwarming.swarmer_get_priorities_intervals (as_file file) with _ -> [] with
+  | [] -> []
+  | ((_,prio)::_ as l) ->
+  let intervals = ref l in
+  let prio = ref prio in
+  let rec count_intervals_till bytes =
+    let rec loop acc_prio = function
+    | (i_start,i_prio) :: tail when i_start < bytes ->
+        prio := i_prio;
+        loop (min acc_prio i_prio) tail
+    | ((i_start,i_prio) :: _ as l) when i_start = bytes ->
+        prio := i_prio;
+        intervals := l;
+        acc_prio
+    | l -> intervals := l; acc_prio
+    in
+    loop !prio !intervals
+  in
+  let r = ref [] in
+  Unix32.subfile_tree_map (file_fd file)
+    begin fun fname start length current_length ->
+      let prio = count_intervals_till (start ++ length) in
+      r := (fname, length, prio) :: !r
+    end;
+  List.rev !r
+
 let op_file_print file o =
 
+  let subfiles =
+    let intervals = ref (get_subfile_priorities file) in
+    List.map begin fun (name,size,magic) ->
+    let magic = match magic with None -> "" | Some m -> Printf.sprintf " / %s" m in
+    match !intervals with
+    | [] -> (name,size,magic,None)
+    | (i_name,i_size,i_prio)::t ->
+      if !verbose then
+        lprintf_nl "%S = %S %Ld = %Ld | priority %d" name i_name size i_size i_prio;
+      intervals := t;
+      if name = i_name && size = i_size then (* sanity check *)
+        (name,size,magic,Some i_prio)
+      else 
+        (name,size,magic,None)
+    end file.file_files 
+  in
   let buf = o.conn_buf in
   if use_html_mods o then begin
   Printf.bprintf buf "\\</tr\\>\\<tr class=\\\"dl-%d\\\"\\>" (html_mods_cntr ());
@@ -402,21 +447,39 @@ let op_file_print file o =
   end;
   (* -- End bad -- *)
 
+  let extra =
+    match List.fold_left (fun acc subfile ->
+      match acc, subfile with
+      | (Some false|None),(_,_,_,Some prio) when prio > 0 -> Some true
+      | None,(_,_,_,Some 0) -> Some false
+      | None,(_,_,_,None) -> None
+      | acc,_ -> acc) None subfiles
+    with
+    | None -> ""
+    | Some dl ->
+      Printf.sprintf ", \\<a title=\\\"toggle all files\\\" href=\\\"submit?q=debug_set_subfile_prio+%d+%d+%d+%d\\\"\\>%s\\</a\\>"
+        (file_num file) (if dl then 0 else 1) 0 (List.length subfiles - 1)
+        (if dl then "unselect all" else "select all")
+  in
+  Printf.bprintf buf "\\</tr\\>\\<tr class=\\\"dl-%d\\\"\\>" (html_mods_cntr ());
+  html_mods_td buf [
+    ("Full path to the download", "sr br", "Full path" ^ extra);
+    ("", "sr", file_disk_name file) ];
+
   let cntr = ref 0 in
-  List.iter (fun (filename, size, magic) ->
+  List.iter (fun (filename, size, magic, prio) ->
     Printf.bprintf buf "\\</tr\\>\\<tr class=\\\"dl-%d\\\"\\>" (html_mods_cntr ());
     let fs = Printf.sprintf "File %d" !cntr in
-    let magic_string =
-      match magic with 
-            None -> ""
-      | Some m -> Printf.sprintf " / %s" m;
+    let extra = match prio with
+      | None -> ""
+      | Some prio -> Printf.sprintf ", \\<a title=\\\"toggle file\\\" href=\\\"submit?q=debug_set_subfile_prio+%d+%d+%d\\\"\\>priority %d\\</a\\>" (file_num file) (if prio = 0 then 1 else 0) !cntr prio
     in
     html_mods_td buf [
-      (fs, "sr br", fs);
-      ("", "sr", (Printf.sprintf "%s (%Ld bytes)%s" filename size magic_string)) 
+      (fs, "sr br", fs ^ extra);
+      ("", "sr", (Printf.sprintf "%s (%Ld bytes)%s" filename size magic)) 
     ];
     incr cntr;
-  ) file.file_files
+  ) subfiles 
   end (* use_html_mods *)
   else begin
 
@@ -440,15 +503,11 @@ let op_file_print file o =
   if file.file_encoding <> "" then Printf.bprintf buf "Encoding: %s\n" file.file_encoding;
   if file.file_files <> [] then Printf.bprintf buf "Subfiles: %d\n" (List.length file.file_files);
   let cntr = ref 0 in
-  List.iter (fun (filename, size, magic) ->
+  List.iter (fun (filename, size, magic, prio) ->
     incr cntr;
-    let magic_string =
-      match magic with 
-        None -> ""
-      | Some m -> Printf.sprintf " / %s" m;
-    in
-    Printf.bprintf buf "File %d: %s (%Ld bytes)%s\n" !cntr filename size magic_string
-  ) file.file_files
+    let prio = match prio with Some n -> Printf.sprintf ", priority %d" n | None -> "" in
+    Printf.bprintf buf "File %d: %s (%Ld bytes%s)%s\n" !cntr filename size prio magic
+  ) subfiles
   end
 
 let op_file_print_sources file o =
diff --git src/utils/lib/unix32.ml src/utils/lib/unix32.ml
index 446f990..a3d1e90 100644
--- src/utils/lib/unix32.ml
+++ src/utils/lib/unix32.ml
@@ -454,6 +454,14 @@ module MultiFile = struct
           find_file
             (if file_pos < pos then tree1 else tree2) file_pos
 
+    let rec subfile_tree_map indent tree f=
+      match tree with
+        | Leaf file -> 
+            f file.filename file.pos file.len file.current_len
+        | Node (pos, tree1, tree2) ->
+            subfile_tree_map (indent ^ "  ") tree1 f;
+            subfile_tree_map (indent ^ "  ") tree2 f
+              
     let rec print_tree indent tree =
       match tree with
         Leaf file -> lprintf_nl "%s  - %s (%Ld,%Ld)"
@@ -1656,7 +1664,29 @@ when these two files have already been partially downloaded ? This
       let shared_end = shared_begin ++ shared_len in
       ()
 *)      
-  end
+end
+
+(* subfile tree map function*)
+let subfile_tree_map t f =
+  match t.file_kind with
+    | MultiFile t -> MultiFile.subfile_tree_map "" t.MultiFile.tree f; ()
+    | _ -> ()
+        
+
+let find_file t chunk_begin = 
+  match t.file_kind with
+    | MultiFile t ->  
+        let (sf, tail) = (MultiFile.find_file t chunk_begin) in
+          (sf.MultiFile.filename, sf.MultiFile.pos , sf.MultiFile.len)
+    | _ -> ("unimplemeted" , 0L, 0L)
+
+let find_file_index t index = 
+  match t.file_kind with
+    | MultiFile t ->  
+        let sf = List.nth t.MultiFile.files index in
+          (sf.MultiFile.filename, sf.MultiFile.pos , sf.MultiFile.len)
+    | _ -> ("unimplemeted" , 0L, 0L)
+
 type t = file
 
 (*
diff --git src/utils/lib/unix32.mli src/utils/lib/unix32.mli
index 9ad122b..1ea0616 100644
--- src/utils/lib/unix32.mli
+++ src/utils/lib/unix32.mli
@@ -105,3 +105,6 @@ val diskused : string -> int64 option
 val percentused : string -> int option
 val percentfree : string -> int option
 val filesystem : string -> string
+val subfile_tree_map : t -> (string -> int64 -> int64 -> int64-> unit)  ->  unit
+val find_file : t -> int64 -> (string * int64 * int64)
+val find_file_index : t -> int -> (string * int64 * int64)
